ITPub博客

首页 > 数据库 > Oracle > 揭密Java安全规则对Aurigma Upload Suite的影响

揭密Java安全规则对Aurigma Upload Suite的影响

Oracle 作者:396201468 时间:2014-01-25 17:41:00 0 删除 编辑

数月前,Oracle发布Java 7 Update 45时,便有不少开发者注意到一个奇怪的现象。如果用户不更新Java,uploader便无法正常工作(即使1小时前还能正常工作)。

典型的症状是 - uploader开始发送空的请求。此症状的原因很简单-Java阻止了LiveConnect模块,而该模块正是调用JavaScript的必要模块。这样一来,uploader设置无法初始化,因此它不知道是否需要发送原文件或缩略图,最终uploader开始发送空的请求。

说来这个问题比较奇怪,但是解决的方法却是非常简单,只需要更新到最新的Java版本即可。Oracle会提示安装Java Update 最新版本,然后问题便可得以解决。

不久前,随着Java 7 Update 51的正式发布,上述情况又回来了。如果用户还是使用Java 7u45,LiveConnect再次无法正常工作,直到用户更新至Java最近版本。

由于Java 7u51比Java 7 Update 45更具破坏性,用户尽量避免更新它,故而uploader又出现问题。

阅读完Oracle网站上的几篇文章后,终于发现为何会出现这样的问题:

安全底线(Security Baseline)

所谓的Security Baseline,其实是专为Java而定义。简单地说,安全底线(Security Baseline)是当前Oracle认为安全的最低Java版本。如果Java版本是最新的,Oracle会认为其处于安全底线之上,并且不会产生一些额外的问题干扰用户。相反,如果Java版本低于其安全底线,Oracle会认为它存在潜在危险。

如何确定Java版本低于或高于安全底线呢?主要有以下两个因素:

1、每一个Java update都包含了一个内置定时炸弹。在Java update发布的数月后,Oracle认为它是安全的(甲骨文会在发行说明中宣布每个Java update的具体到期日)。

2、此外,它会检查Oracle服务器,并验证安全底线是否更新。这样一来,Oracle随时都可以认为Java update已经过时。

如今,Oracle所认可的安全底线是Java 7 Update 51。这就可以解释为何Java 7 Update 45又会出现问题。

Security Baseline(安全底线)和LiveConnect

当applet低于安全底线时,会发生什么情况呢?我没有找到一个完整的列表,但很明显,Oracle认为不该在此情况下使用Java小程序,所以它无法正常工作。

我试图找出为何Java Update过期时,Oracle会阻止LiveConnect。阅读完各种发布说明后,我发现从Java 7 Update 25开始,便有了这种机制,原文如下:

LiveConnect calls from JavaScript to Java API are blocked when the Java Control Panel security slider is set to Very High level, or when the slider is at the default High level and the JRE has either expired or is below the security baseline.

结论

为了使Java uploader顺利工作,唯一的方法就是更新Java。对于那些不愿更新Java版本的少数用户,可以将安全级别更改至中等。

来自 “ ITPUB博客 ” ,链接:http://blog.itpub.net/22873720/viewspace-1109711/,如需转载,请注明出处,否则将追究法律责任。

上一篇: 没有了~
下一篇: 没有了~
请登录后发表评论 登录
全部评论

注册时间:2009-11-14